.src_dir_ref_storage:
  before_script:
    - mkdir build || true
    - pwd > build/original_source_directory

.src_dir_ref_replacement: &src_dir_ref_replacement
  - old_sdir=`cat build/original_source_directory`
  - this_sdir=`pwd`
  - find build
    -type f -a
    \! \(
      -perm /111 -o
      \(
        -name '*.o' -o -name '*.a' -o -name '*.so'
      \)
    \)
    -exec sed -i "s|$old_sdir|$this_sdir|g" {} +

.cpp_common:
  image:
    name: $SKA_PST_DSP_TOOLS_IMAGE
    pull_policy: always
  variables:
    DSPSR_INST: $CI_PROJECT_DIR/build/dspsr-install
  tags: [ska-default]

.cpp_common.artifact-builder:
  extends: .cpp_common
  before_script:
    - !reference [.src_dir_ref_storage, before_script]
    - apt-get update -y
    - apt-get install -y $(cat dependencies/buildtime.apt.txt)
    - export PATH=${DSPSR_INST}/bin:${PATH}
    - export LD_LIBRARY_PATH=${DSPSR_INST}/lib:${LD_LIBRARY_PATH}

  artifacts:
    paths:
      - build

.cpp_common.artifact-retriever:
  extends: .cpp_common
  before_script:
    - *src_dir_ref_replacement

.cpp_common.tester:
  extends: .cpp_common
  before_script:
    - *src_dir_ref_replacement
    - apt-get update -y
    - apt-get install -y $(cat dependencies/runtime.apt.txt)

dynamic_vars:
  stage: .pre
  before_script:
    - printenv | grep BRANCH
  script:
    - echo "SKA_PST_OCI_TAG=$(grep -m 1 -o '[0-9].*' .release)-dev.c${CI_COMMIT_SHORT_SHA}" >> build.env
    - echo "SKA_PST_OCI_RELEASE=$(grep -m 1 -o '[0-9].*' .release)" >> build.env
  artifacts:
    reports:
      dotenv: build.env

.cpp_common.lint:
  extends: .cpp_common.artifact-retriever
  image: "registry.gitlab.com/ska-telescope/pst/ska-pst/ska-pst-core-builder:$SKA_PST_OCI_TAG"
  needs:
  - dynamic_vars
  - build_cpp_clang
  - oci-image-core-builder-build
  dependencies:
  - dynamic_vars
  - build_cpp_clang
  - oci-image-core-builder-build
